<template>
  <div class="social-article">
    <p class="title-component">
      {{ $t('bounty.social.title') }}
    </p>
    <template v-if="settings">
      <bounty-post
        :settings="settings"
        :posts="bitcoinTalkPosts"
        @created="getAllPosts"
        title="bounty.social.bitcoin_talk_post.title"
        type="bitcoin_talk_post"
        tooltip="bounty.social.bitcoin_talk_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="steemitPosts"
        @created="getAllPosts"
        title="bounty.social.steemit_post.title"
        type="steemit_post"
        tooltip="bounty.social.steemit_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="redditPosts"
        @created="getAllPosts"
        title="bounty.social.reddit_post.title"
        type="reddit_post"
        tooltip="bounty.social.reddit_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="mediumPosts"
        @created="getAllPosts"
        title="bounty.social.medium_post.title"
        type="medium_post"
        tooltip="bounty.social.medium_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="linkedinPosts"
        @created="getAllPosts"
        title="bounty.social.linkedin_post.title"
        type="linkedin_post"
        tooltip="bounty.social.linkedin_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="facebookPosts"
        @created="getAllPosts"
        title="bounty.social.facebook_post.title"
        type="facebook_post"
        tooltip="bounty.social.facebook_post.tooltip"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="blogPosts"
        @created="getAllPosts"
        title="bounty.social.blog_post.title"
        type="blog_post"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="otherWebsitePosts"
        @created="getAllPosts"
        title="bounty.social.other_website_post.title"
        type="other_website_post"
        >
      </bounty-post>
      <bounty-post
        :settings="settings"
        :posts="otherVideoPosts"
        @created="getAllPosts"
        title="bounty.social.other_video_post.title"
        type="other_video_post"
        >
      </bounty-post>
    </template>

    <div class="ctu-total">
      <p class="title">{{ $t('common.heta_tokens') }}</p>
      <div class="number">{{ total | formatCurrencyAmount('heta', '0') }}</div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash';

import rf from '../../../common/requests/RequestFactory';
import BountyPost from './BountyArticleComponent/BountyPost';
import bignumber from 'bignumber.js';

export default {
  props: {
    settings: {
      type: Object,
      default:  null,
      required: true,
    }
  },
  components : {
    BountyPost,
  },
  data () {
    return {
      posts: [],
      bitcoinTalkPosts: [],
      steemitPosts: [],
      redditPosts: [],
      mediumPosts: [],
      linkedinPosts: [],
      facebookPosts: [],
      blogPosts: [],
      otherWebsitePosts: [],
      otherVideoPosts: [],
      total: 0,
    };
  },
  methods: {
    hasProperty (property) {
      return _.has(this.posts, property);
    },
    async getAllPosts () {
      const response = await rf.getRequest('BountyRequest').getAllPosts();
      this.calculatorTotal(response.data);
      this.posts = _.groupBy(response.data, 'type');
      this.initData();
    },
    calculatorTotal (data) {
      const approvedData = data.filter(item => item.status === 'approved');
      this.total = approvedData.reduce((sum, item) => {
        return sum.plus(item.heta_tokens);
      }, bignumber('0')).toString();
    },
    initData () {
      this.bitcoinTalkPosts = this.hasProperty('bitcoin_talk_post') ? this.posts.bitcoin_talk_post : [];
      this.steemitPosts = this.hasProperty('steemit_post') ? this.posts.steemit_post : [];
      this.redditPosts = this.hasProperty('reddit_post') ? this.posts.reddit_post : [];
      this.mediumPosts = this.hasProperty('medium_post') ? this.posts.medium_post : [];
      this.linkedinPosts = this.hasProperty('linkedin_post') ? this.posts.linkedin_post : [];
      this.facebookPosts = this.hasProperty('facebook_post') ? this.posts.facebook_post : [];
      this.blogPosts = this.hasProperty('blog_post') ? this.posts.blog_post : [];
      this.otherWebsitePosts = this.hasProperty('other_website_post') ? this.posts.other_website_post : [];
      this.otherVideoPosts = this.hasProperty('other_video_post') ? this.posts.other_video_post : [];
    }
  },
  created () {
    this.getAllPosts()
  },
}
</script>

<style lang="scss">
  @import '../../../../sass/variables';
  .social-article {
    padding: 25px 0 10px;
    border-bottom: 1px solid #efefef;

    .title-component {
      margin-bottom: 48px;
    }

    .ctu-total {
      font-size: 0;
      padding: 5px 0px 30px;
      .title {
        width: 259px !important;
        text-align: right;
        margin-right: 49px !important;
      }

    }
  }

  .article-item {
    margin-bottom: 22px;
    font-size: 0;
    .article__title {
      display: inline-block;
      font-size: $small;
      font-weight: bold;
      color: $black;
      max-width: 259px;
      margin-right: 49px;
    }

    .article__content {
      color: #858585;
      font-size: 0.75rem;
      vertical-align: top;
      display: inline-block;
      width: calc(100% - 308px);
    }

    .article__text {
      font-size: 14px;
      color: $gray;
      margin-bottom: 3px;
    }

    .article__input-link {
      font-size: 0;
      margin-bottom: 7px;
    }

    .article__url {
      vertical-align: middle;
      padding: 4px 10px;
      width: calc(100% - 90px) !important;
      font-size: 14px;
      color: #222c3c;
      border: 1px solid #d2d2d2;
      background-color: #fff;
      border-radius: 74px;

      &::placeholder {
        color: transparent;
      }
    }

    .article__link-group {
      width: calc(100% - 90px);
      .article__link-item {
        font-size: 0;
        margin-bottom: 10px;

        .bounty,
        .link,
        .status {
          display: inline-block;
          width: 20%;
          padding: 5px 10px;
          margin-right: 10px;
          font-size: 14px;
          background-color: #ebebeb;
          vertical-align: middle;
          color: #222c3c;
          border-radius: 74px;
          border: 1px solid #d8dbe7;
        }

        .link {
          color: #222c3c;
          width: calc(100% - 220px);
          white-space: nowrap;
          overflow: hidden;
          text-overflow: ellipsis;
        }
        .bounty {
          text-align: center;
          width: 100px;
        }
        .status {
          margin-right: 0;
          color: #ffb200;
          width: 100px;
          text-align: center;

          &.approved {
            color: #09a532;
          }
          &.rejected {
            color: red;
          }
        }
      }
    }
  }

  .error {
    color: red;
    display: inline-block;
    margin-top: 5px;
    font-size: $tiny;
    display: none;
    transition: all 0.3s ease-in-out;

    &.show {
      display: block;
      padding: 0 0 0 19px !important;
    }
  }
</style>
